SELECT 'Upgrading MetaStore schema from 1.2.0 to 2.0.0' AS Status from dual;

--@022-HIVE-11970.oracle.sql;
ALTER TABLE COLUMNS_V2 MODIFY (
  "COLUMN_NAME" VARCHAR2(1000)
);

ALTER TABLE PART_COL_PRIVS MODIFY (
  "COLUMN_NAME" VARCHAR2(1000)
);

ALTER TABLE TBL_COL_PRIVS MODIFY (
  "COLUMN_NAME" VARCHAR2(1000)
);

ALTER TABLE SORT_COLS MODIFY (
  "COLUMN_NAME" VARCHAR2(1000)
);

ALTER TABLE TAB_COL_STATS MODIFY (
  "COLUMN_NAME" VARCHAR2(1000)
);

ALTER TABLE PART_COL_STATS MODIFY (
  "COLUMN_NAME" VARCHAR2(1000)
);

--@023-HIVE-12807.oracle.sql;
ALTER TABLE COMPACTION_QUEUE ADD CQ_HIGHEST_TXN_ID NUMBER(19);

--@024-HIVE-12814.oracle.sql;
ALTER TABLE COMPACTION_QUEUE ADD CQ_META_INFO BLOB;

--@025-HIVE-12816.oracle.sql;
ALTER TABLE COMPACTION_QUEUE ADD CQ_HADOOP_JOB_ID varchar2(32);

--@026-HIVE-12818.oracle.sql;
CREATE TABLE COMPLETED_COMPACTIONS (
  CC_ID NUMBER(19) PRIMARY KEY,
  CC_DATABASE varchar(128) NOT NULL,
  CC_TABLE varchar(128) NOT NULL,
  CC_PARTITION varchar(767),
  CC_STATE char(1) NOT NULL,
  CC_TYPE char(1) NOT NULL,
  CC_WORKER_ID varchar(128),
  CC_START NUMBER(19),
  CC_END NUMBER(19),
  CC_RUN_AS varchar(128),
  CC_HIGHEST_TXN_ID NUMBER(19),
  CC_META_INFO BLOB,
  CC_HADOOP_JOB_ID varchar2(32)
) ROWDEPENDENCIES;



--@027-HIVE-12819.oracle.sql;
ALTER TABLE TXNS ADD TXN_AGENT_INFO varchar2(128);

--@028-HIVE-12821.oracle.sql;
ALTER TABLE TXNS ADD TXN_HEARTBEAT_COUNT number(10);
ALTER TABLE HIVE_LOCKS ADD HL_HEARTBEAT_COUNT number(10);

--@029-HIVE-12822.oracle.sql;
ALTER TABLE TXNS ADD TXN_META_INFO varchar2(128);

--@030-HIVE-12823.oracle.sql;
ALTER TABLE HIVE_LOCKS ADD HL_AGENT_INFO varchar2(128);

--@031-HIVE-12381.oracle.sql;
ALTER TABLE HIVE_LOCKS ADD HL_BLOCKEDBY_EXT_ID number(19);
ALTER TABLE HIVE_LOCKS ADD HL_BLOCKEDBY_INT_ID number(19);

--@032-HIVE-12832.oracle.sql;
CREATE TABLE AUX_TABLE (
  MT_KEY1 varchar2(128) NOT NULL,
  MT_KEY2 number(19) NOT NULL,
  MT_COMMENT varchar2(255),
  PRIMARY KEY(MT_KEY1, MT_KEY2)
);


UPDATE VERSION SET SCHEMA_VERSION='2.0.0', VERSION_COMMENT='Hive release version 2.0.0' where VER_ID=1;
SELECT 'Finished upgrading MetaStore schema from 1.2.0 to 2.0.0' AS Status from dual;
